package content.data

import core.api.consts.Items
import core.game.node.item.Item

/**
 * @author Vexia
 */
enum class Lamps(val item: Int, val exp: Int, val levelRequirement: Int = 0) {
    GENIE_LAMP(Items.LAMP_2528, 10),
    STRONGHOLD_LAMP(Items.ANTIQUE_LAMP_4447, 500),

    BLESSED_LAMP(Items.BLESSED_LAMP_10889, 5000, 30),
    UNASSIGNED_0(Items.ANTIQUE_LAMP_11189, 1),
    UNASSIGNED_1(Items.ANTIQUE_LAMP_12627, 1),

    COMBAT_LAMP(Items.COMBAT_LAMP_10586, 7000),
    DREAMY_LAMP(Items.DREAMY_LAMP_11157, 15000),
    MYSTERIOUS_LAMP(Items.MYSTERIOUS_LAMP_13227, 10000, 30),

    QUEST_REWARD_LAMP_1(Items.ANTIQUE_LAMP_7498, 2500, 30),
    QUEST_REWARD_LAMP_2(Items.ANTIQUE_LAMP_13446, 600, 1),
    QUEST_REWARD_LAMP_3(Items.ANTIQUE_LAMP_13447, 5000, 30),
    QUEST_REWARD_LAMP_4(Items.ANTIQUE_LAMP_13448, 7000, 50),
    QUEST_REWARD_LAMP_5(Items.ANTIQUE_LAMP_13463, 20000, 50),

    K_ACHIEVEMENT_1(Items.ANTIQUE_LAMP_11137, 1000, 30),
    K_ACHIEVEMENT_2(Items.ANTIQUE_LAMP_11139, 5000, 40),
    K_ACHIEVEMENT_3(Items.ANTIQUE_LAMP_11141, 10000, 50),

    V_ACHIEVEMENT_1(Items.ANTIQUE_LAMP_11753, 1000, 30),
    V_ACHIEVEMENT_2(Items.ANTIQUE_LAMP_11754, 5000, 40),
    V_ACHIEVEMENT_3(Items.ANTIQUE_LAMP_11755, 10000, 50),

    L_ACHIEVEMENT_1(Items.ANTIQUE_LAMP_11185, 500, 1),
    L_ACHIEVEMENT_2(Items.ANTIQUE_LAMP_11186, 1000, 30),
    L_ACHIEVEMENT_3(Items.ANTIQUE_LAMP_11187, 1500, 35),

    FALLY_ACHIEVEMENT_1(Items.ANTIQUE_LAMP_14580, 1000, 30),
    FALLY_ACHIEVEMENT_2(Items.ANTIQUE_LAMP_14581, 5000, 40),
    FALLY_ACHIEVEMENT_3(Items.ANTIQUE_LAMP_14582, 10000, 50),

    FREM_ACHIEVEMENT_1(Items.ANTIQUE_LAMP_14574, 5000, 30),
    FREM_ACHIEVEMENT_2(Items.ANTIQUE_LAMP_14575, 10000, 40),
    FREM_ACHIEVEMENT_3(Items.ANTIQUE_LAMP_14576, 15000, 50),

    SEERS_ACHIEVEMENT_1(Items.ANTIQUE_LAMP_14633, 1000, 30),
    SEERS_ACHIEVEMENT_2(Items.ANTIQUE_LAMP_14634, 5000, 40),
    SEERS_ACHIEVEMENT_3(Items.ANTIQUE_LAMP_14635, 10000, 50),

    EXP_BOOK_3(Items.TOME_OF_XP_3_9656, 2000, 30),
    EXP_BOOK_2(Items.TOME_OF_XP_2_9657, 2000, 30),
    EXP_BOOK_1(Items.TOME_OF_XP_1_9658, 2000, 30),

    EXP_BOOK_2ND_3(Items.TOME_OF_XP_2ND_ED_3_13160, 2500, 35),
    EXP_BOOK_2ND_2(Items.TOME_OF_XP_2ND_ED_2_13161, 2500, 35),
    EXP_BOOK_2ND_1(Items.TOME_OF_XP_2ND_ED_1_13162, 2500, 35);

    companion object {
        fun forItem(item: Item): Lamps? {
            for (x in values()) {
                if (x.item == item.id) {
                    return x
                }
            }
            return null
        }
    }
}
